//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "refdlg.h"
#include "rtklib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRefDialog *RefDialog;
//---------------------------------------------------------------------------
__fastcall TRefDialog::TRefDialog(TComponent* Owner)
	: TForm(Owner)
{
	Pos[0]=Pos[1]=Pos[2]=RovPos[0]=RovPos[1]=RovPos[2]=0.0;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::FormShow(TObject *Sender)
{
	StaList->Cells[0][0]=" No";
	StaList->Cells[1][0]=" Latitude(deg)";
	StaList->Cells[2][0]=" Longitude(deg)";
	StaList->Cells[3][0]=" Height(m)";
	StaList->Cells[4][0]=" Id";
	StaList->Cells[5][0]=" Name";
	StaList->Cells[6][0]=" Dist(km)";
	LoadList();
	
	if (norm(RovPos,3)>0.0) SortList(6);
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::StaListMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	int col,row;
	StaList->MouseToCell(X,Y,col,row);
	if (row==0) SortList(col);
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::StaListDblClick(TObject *Sender)
{
	ModalResult=InputRef()?mrOk:mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::BtnOKClick(TObject *Sender)
{
	ModalResult=InputRef()?mrOk:mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::BtnLoadClick(TObject *Sender)
{
	OpenDialog->FileName=StaPosFile;
	if (OpenDialog->Execute()!=mrOk) return;
	StaPosFile=OpenDialog->FileName;
	LoadList();
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::LoadList(void)
{
	FILE *fp;
	char buff[256],code[256],name[256],*p;
	double pos[3];
	if (!(fp=fopen(StaPosFile.c_str(),"r"))) return;
	int n=0;
	while (fgets(buff,sizeof(buff),fp)) {
		if (p=strchr(buff,'%')) *p='\0';
		pos[0]=pos[1]=pos[2]=0.0; code[0]='\0'; name[0]='\0';
		if (sscanf(buff,"%lf %lf %lf %s %s",pos,pos+1,pos+2,code,name)<3) continue;
		StaList->RowCount=++n+1;
		AddRef(n,pos,code,name);
	}
	if (n==0) {
		StaList->RowCount=2;
		for (int i=0;i<StaList->ColCount;i++) StaList->Cells[i][1]="";
	}
	fclose(fp);
	UpdateDist();
	Caption=StaPosFile;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::SortList(int col)
{
	for (int i=1;i<StaList->RowCount;i++) {
		int j=i;
		for (int k=i+1;k<StaList->RowCount;k++) {
			char *s1=StaList->Cells[col][j].c_str();
			char *s2=StaList->Cells[col][k].c_str();
			if (strcmp(s1,s2)>0) j=k;
		}
		if (j==i) continue;
		for (int k=0;k<StaList->ColCount;k++) {
			AnsiString s=StaList->Cells[k][i];
			StaList->Cells[k][i]=StaList->Cells[k][j];
			StaList->Cells[k][j]=s;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::AddRef(int n, double *pos, const char *code,
                                   const char *name)
{
	AnsiString s;
	int i=StaList->RowCount;
	StaList->Cells[0][i-1]=s.sprintf("%4d",n);
	StaList->Cells[1][i-1]=s.sprintf("%13.9f",pos[0]);
	StaList->Cells[2][i-1]=s.sprintf("%14.9f",pos[1]);
	StaList->Cells[3][i-1]=s.sprintf("%10.4f",pos[2]);
	StaList->Cells[4][i-1]=code;
	StaList->Cells[5][i-1]=name;
	StaList->Cells[6][i-1]="";
}
//---------------------------------------------------------------------------
int __fastcall TRefDialog::InputRef(void)
{
	int n=StaList->RowCount;
	TGridRect r=StaList->Selection; if (r.Top<0||n-1<=r.Top) return 0;
	Pos[0]=StaList->Cells[1][r.Top].ToDouble();
	Pos[1]=StaList->Cells[2][r.Top].ToDouble();
	Pos[2]=StaList->Cells[3][r.Top].ToDouble();
	StaId  =StaList->Cells[4][r.Top];
	StaName=StaList->Cells[5][r.Top];
	return 1;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::UpdateDist(void)
{
	double pos[3],ru[3],rr[3];
	for (int i=0;i<3;i++) pos[i]=RovPos[i];
	if (norm(pos,3)<=0.0) return;
	pos[0]*=D2R; pos[1]*=D2R; pos2ecef(pos,ru);
	for (int i=1;i<StaList->RowCount;i++) {
		if (StaList->Cells[1][i]=="") continue;
		pos[0]=StaList->Cells[1][i].ToDouble()*D2R;
		pos[1]=StaList->Cells[2][i].ToDouble()*D2R;
		pos[2]=StaList->Cells[3][i].ToDouble();
		pos2ecef(pos,rr);
		for (int j=0;j<3;j++) rr[j]-=ru[j];
		AnsiString s;
		StaList->Cells[6][i]=s.sprintf("%6.1f",norm(rr,3)/1E3);
	}
}
//---------------------------------------------------------------------------

