//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "rtklib.h"
#include "refdlg.h"
#include "navimain.h"
#include "serioptdlg.h"
#include "cmdoptdlg.h"
#include "fileoptdlg.h"
#include "tcpoptdlg.h"
#include "instrdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TInputStrDialog *InputStrDialog;
//---------------------------------------------------------------------------
__fastcall TInputStrDialog::TInputStrDialog(TComponent* Owner)
	: TForm(Owner)
{
	Format1->Items->Clear();
	Format2->Items->Clear();
	for (int i=0;rcvnamelist[i];i++) {
		Format1->Items->Add(rcvnamelist[i]);
		Format2->Items->Add(rcvnamelist[i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::FormShow(TObject *Sender)
{
	AnsiString s;
	StreamC1  ->Checked  =Stream[0]>0;
	StreamC2  ->Checked  =Stream[1]>0;
	Stream1   ->ItemIndex=Stream[0]>0?Stream[0]-1:0;
	Stream2   ->ItemIndex=Stream[1]>0?Stream[1]-1:0;
	Format1   ->ItemIndex=Format[0];
	Format2   ->ItemIndex=Format[1];
	FilePath1 ->Text     =GetFilePath(Paths[0][2]);
	FilePath2 ->Text     =GetFilePath(Paths[1][2]);
	NmeaReqL  ->ItemIndex=NmeaReq;
	TimeTagC  ->Checked  =TimeTag;
	TimeSpeedL->Text     =TimeSpeed;
	TimeStartE->Text     =TimeStart;
	NmeaPos1  ->Text     =s.sprintf("%.9f",NmeaPos[0]);
	NmeaPos2  ->Text     =s.sprintf("%.9f",NmeaPos[1]);
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnOkClick(TObject *Sender)
{
	Stream[0]  =StreamC1->Checked?Stream1->ItemIndex+1:0;
	Stream[1]  =StreamC2->Checked?Stream2->ItemIndex+1:0;
	Format[0]  =Format1   ->ItemIndex;
	Format[1]  =Format2   ->ItemIndex;
	Paths[0][2]=SetFilePath(FilePath1->Text);
	Paths[1][2]=SetFilePath(FilePath2->Text);
	NmeaReq    =NmeaReqL  ->ItemIndex;
	TimeTag    =TimeTagC  ->Checked;
	TimeSpeed  =TimeSpeedL->Text;
	TimeStart  =TimeStartE->Text;
	NmeaPos[0] =NmeaPos1  ->Text.ToDouble();
	NmeaPos[1] =NmeaPos2  ->Text.ToDouble();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::StreamC1Click(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------

void __fastcall TInputStrDialog::StreamC2Click(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::Stream1Change(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::Stream2Change(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::NmeaReqCClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::TimeTagCClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::NmeaReqLChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TInputStrDialog::GetFilePath(AnsiString path)
{
	char *p,*q,buff[1024];
	strcpy(buff,path.c_str());
	if ((p=strstr(buff,"::"))) *p='\0';
	return (path=buff);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TInputStrDialog::SetFilePath(AnsiString path)
{
	if (TimeTagC->Checked     ) path+="::T";
	if (TimeStartE->Text!="0" ) path+="::+"+TimeStartE->Text;
	if (TimeSpeedL->Text!="x1") path+="::"+TimeSpeedL->Text;
	return path;
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnStr1Click(TObject *Sender)
{
	switch (Stream1->ItemIndex) {
		case 0: SerialOpt(0,0); break;
		case 1: TcpOpt(0,1); break;
		case 2: TcpOpt(0,0); break;
		case 3: TcpOpt(0,3); break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnStr2Click(TObject *Sender)
{
	switch (Stream2->ItemIndex) {
		case 0: SerialOpt(1,0); break;
		case 1: TcpOpt(1,1); break;
		case 2: TcpOpt(1,0); break;
		case 3: TcpOpt(1,3); break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnCmd1Click(TObject *Sender)
{
	CmdOptDialog->Cmds  [0]=Cmds  [0][0];
	CmdOptDialog->Cmds  [1]=Cmds  [0][1];
	CmdOptDialog->CmdEna[0]=CmdEna[0][0];
	CmdOptDialog->CmdEna[1]=CmdEna[0][1];
	if (CmdOptDialog->ShowModal()!=mrOk) return;
	Cmds  [0][0]=CmdOptDialog->Cmds  [0];
	Cmds  [0][1]=CmdOptDialog->Cmds  [1];
	CmdEna[0][0]=CmdOptDialog->CmdEna[0];
	CmdEna[0][1]=CmdOptDialog->CmdEna[1];
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnCmd2Click(TObject *Sender)
{
	CmdOptDialog->Cmds  [0]=Cmds  [1][0];
	CmdOptDialog->Cmds  [1]=Cmds  [1][1];
	CmdOptDialog->CmdEna[0]=CmdEna[1][0];
	CmdOptDialog->CmdEna[1]=CmdEna[1][1];
	if (CmdOptDialog->ShowModal()!=mrOk) return;
	Cmds  [1][0]=CmdOptDialog->Cmds  [0];
	Cmds  [1][1]=CmdOptDialog->Cmds  [1];
	CmdEna[1][0]=CmdOptDialog->CmdEna[0];
	CmdEna[1][1]=CmdOptDialog->CmdEna[1];
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnPosClick(TObject *Sender)
{
	AnsiString s;
	RefDialog->RovPos[0]=NmeaPos1->Text.ToDouble();
	RefDialog->RovPos[1]=NmeaPos2->Text.ToDouble();
	RefDialog->StaPosFile=MainForm->StaPosFileF;
	if (RefDialog->ShowModal()!=mrOk) return;
	NmeaPos1->Text=s.sprintf("%.9f",RefDialog->Pos[0]);
	NmeaPos2->Text=s.sprintf("%.9f",RefDialog->Pos[1]);
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::SerialOpt(int index, int opt)
{
	SerialOptDialog->Path=Paths[index][0];
	SerialOptDialog->Opt=opt;
	if (SerialOptDialog->ShowModal()!=mrOk) return;
	Paths[index][0]=SerialOptDialog->Path;
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnFile1Click(TObject *Sender)
{
	OpenDialog->FileName=FilePath1->Text;
	if (!OpenDialog->Execute()) return;
	FilePath1->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::BtnFile2Click(TObject *Sender)
{
	OpenDialog->FileName=FilePath2->Text;
	if (!OpenDialog->Execute()) return;
	FilePath2->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::TcpOpt(int index, int opt)
{
	TcpOptDialog->Path=Paths[index][1];
	TcpOptDialog->Opt=opt;
	for (int i=0;i<10;i++) {
		TcpOptDialog->History[i]=History[i];
		TcpOptDialog->MntpHist[i]=MntpHist[i];
	}
	if (TcpOptDialog->ShowModal()!=mrOk) return;
	Paths[index][1]=TcpOptDialog->Path;
	for (int i=0;i<10;i++) {
		History[i]=TcpOptDialog->History[i];
		MntpHist[i]=TcpOptDialog->MntpHist[i];
	}
}
//---------------------------------------------------------------------------
void __fastcall TInputStrDialog::UpdateEnable(void)
{
	int ena1=StreamC1->Checked&&Stream1->ItemIndex==4||
             StreamC2->Checked&&Stream2->ItemIndex==4;
	int ena2=StreamC2->Checked&&Stream2->ItemIndex<=3;
	
	Stream1   ->Enabled=StreamC1->Checked;
	Stream2   ->Enabled=StreamC2->Checked;
	BtnStr1   ->Enabled=StreamC1->Checked&&Stream1->ItemIndex<=3;
	BtnStr2   ->Enabled=StreamC2->Checked&&Stream2->ItemIndex<=3;
	BtnCmd1   ->Enabled=StreamC1->Checked&&Stream1->ItemIndex==0;
	BtnCmd2   ->Enabled=StreamC2->Checked&&Stream2->ItemIndex==0;
	Format1   ->Enabled=StreamC1->Checked;
	Format2   ->Enabled=StreamC2->Checked;
	
	LabelNmea ->Enabled=ena2;
	NmeaReqL  ->Enabled=ena2;
	NmeaPos1  ->Enabled=ena2&&NmeaReqL->ItemIndex==1;
	NmeaPos2  ->Enabled=ena2&&NmeaReqL->ItemIndex==1;
	BtnPos    ->Enabled=ena2&&NmeaReqL->ItemIndex==1;
	
	LabelF1   ->Enabled=ena1;
	FilePath1 ->Enabled=StreamC1->Checked&&Stream1->ItemIndex==4;
	FilePath2 ->Enabled=StreamC2->Checked&&Stream2->ItemIndex==4;
	BtnFile1  ->Enabled=StreamC1->Checked&&Stream1->ItemIndex==4;
	BtnFile2  ->Enabled=StreamC2->Checked&&Stream2->ItemIndex==4;
	TimeTagC  ->Enabled=ena1;
	TimeStartE->Enabled=ena1&&TimeTagC->Checked;
	TimeSpeedL->Enabled=ena1&&TimeTagC->Checked;
	LabelF2   ->Enabled=ena1&&TimeTagC->Checked;
	LabelF3   ->Enabled=ena1&&TimeTagC->Checked;
}
//---------------------------------------------------------------------------

